DCMTK - Bug #388

DICOMDIR causing a crash in the destructor of DcmDicomDir
2011-04-26 00:00 - J6rg Riesmeier

Status: Closed Start date:

Priority: High Due date:

Assignee: Jorg Riesmeier % Done: 100%
Category: Library Estimated time: 0:00 hour
Target version: 3.6.2

Module: dcmdata Compiler:

Operating System:

Description

see http:/forum.dcmtk.org/viewtopic.php?t=2942

The DICOMDIR-file seems to be coded wrongly. The following offset values occur both in OffsetOfTheNextDirectoryRecord as well
as OffsetOfReferencedLowerlLevelDirectoryEntity: 27540, 27972, 28404, 29130, 29424. From there the corresponding records may
have been deleted twice in the destructor. Obviously this should already be detected and reported as an error during reading.

In general the robustness/error tolerance of DICOMDIR code (performance as well, see todo list) needs to be improved. Perhaps the
readability too... :-)

siehe http://forum.dcmtk.org/viewtopic.php?t=2942

Die DICOMDIR-Datei scheint fehlerhaft kodiert zu sein. Die folgenden Offset-Werte kommen sowohl bei
OffsetOfTheNextDirectoryRecord als auch bei OffsetOfReferencedLowerlLevelDirectoryEntity vor: 27540, 27972, 28404, 29130,
29424. Daher werden vermutlich die entsprechenden Records im Destruktor doppelt geléscht. Das sollte natirlich bereits beim
Einlesen erkannt und als Fehler gemeldet werden.

Ganz allgemein sollte die Robustheit/Fehlertoleranz des DICOMDIR-Codes (neben der Performance, siehe To-do-Liste)
verbessert werden. Vielleicht auch die Ubersichtlichkeit ... :-)

History

#1 - 2013-02-13 17:21 - J6rg Riesmeier

- Target version set to 3.6.2

#2 - 2013-03-19 12:37 - Uli Schlachter
- File ignore_duplicates.patch added

The attached patch fixes the crash and some quick testing suggests that it doesn't break anything. However, this seems like something that might
need unit tests and some more careful "by hand" testing. Also, this should likely be an error return instead of a log message.

#3 - 2013-03-19 13:19 - J6rg Riesmeier
- Category set to Library

Please don't output a tag like that (separate group and element number). There is an output operator for tag keys ...

#4 - 2013-04-28 23:39 - Andrew Chiw

- Subject changed from DICOMDIR that caused a crash in the destructor of DemDicomDir to DICOMDIR causing a crash in the destructor of
DcmDicomDir

#5 - 2017-01-27 14:21 - J6rg Riesmeier

- Assignee set to Jorg Riesmeier

#6 - 2017-02-15 18:15 - J6rg Riesmeier
- Status changed from New to Closed

- % Done changed from 0 to 100
Fixed with commit 246cbe6.

Files

ignore_duplicates.patch 1.11 KB 2013-03-19 Uli Schlachter
